Imports Inventor
Imports System.Runtime.InteropServices
Imports Microsoft.Win32
Imports System
'Imports Inventor_Ribbon_Test.AddInRegistration

<ProgId("Inventor_Ribbon_Test.StandardAddInServer"), _
GuidAttribute("AFEBDB0D-C529-4f55-94E7-E7B87807F5A4")> _
Public Class StandardAddInServer
    Implements Inventor.ApplicationAddInServer

    ' Public Shared m_frmDaten As New frm_Daten
    'Public Shared m_ProjektDaten As New
    'Projekt_Daten


#Region "Data Members"

    Private m_InventorApp As Inventor.Application


    Private WithEvents m_TestButtonDef As Inventor.ButtonDefinition
    Private WithEvents m_UserInterfaceEvents As Inventor.UserInterfaceEvents


#End Region

#Region "ApplicationAddInServer Members"

    Private Sub Activate(ByVal AddInSiteObject As Inventor.ApplicationAddInSite, ByVal FirstTime As Boolean) Implements Inventor.ApplicationAddInServer.Activate

        ' Set a reference to the Inventor Application object.
        m_InventorApp = AddInSiteObject.Application

        ' Set a reference to the user interface events.
        m_UserInterfaceEvents = m_InventorApp.UserInterfaceManager.UserInterfaceEvents

        Dim ThisGuidString As String = ""
        Try
            'retrieve the GUID for this class
            Dim ThisGuid As GuidAttribute
            ThisGuid = CType(System.Attribute.GetCustomAttribute(GetType(StandardAddInServer), GetType(GuidAttribute)), GuidAttribute)
            ThisGuidString = "{" & ThisGuid.Value & "}"
        Catch
        End Try

        '------------------------------------------------

        Dim TestIconIPictureDisp As Object = System.Type.Missing

        Try
            Dim TestIconStream As System.IO.Stream = Me.GetType().Assembly.GetManifestResourceStream("Bohrung.BMP") '("Inventor_Ribbon_Test.Test.BMP")
            Dim TestIconImage As System.Drawing.Image = New System.Drawing.Bitmap(TestIconStream)

            TestIconIPictureDisp = ImageToPictureConverter.Convert(TestIconImage)
        Catch ex As Exception
        End Try

        'Button Definition
        m_TestButtonDef = m_InventorApp.CommandManager.ControlDefinitions.AddButtonDefinition("Run TEST", "RunTestCmdIntName", Inventor.CommandTypesEnum.kShapeEditCmdType, ThisGuidString, "Run TEST", "Run TEST", TestIconIPictureDisp, TestIconIPictureDisp)


        'Button Sichtbar Schalten

        m_TestButtonDef.Enabled = True


        'create the command category
        Dim CommandCategory As Inventor.CommandCategory
        CommandCategory = m_InventorApp.CommandManager.CommandCategories.Add("Inventor_Ribbon_Test Mechanism", "AnalyzeMechanismCmdCatIntName", "{5F0B44BA-6655-49E6-8B9E-F1E67535B730}")

        CommandCategory.Add(m_TestButtonDef)

        'if AddIn is called first time, toolbar and add button to toolbar
        Dim CommandBar As Inventor.CommandBar
        Dim AssemEnv As Inventor.Environment
        Dim PartEnv As Inventor.Environment
        Dim DrawEnv As Inventor.Environment

        If FirstTime = True Then

            'create a new toolbar
            CommandBar = m_InventorApp.UserInterfaceManager.CommandBars.Add("Inventor_Ribbon_Test Mechanism", "AnalyzeMechanismToolbarIntName", , "{5F0B44BA-6655-49E6-8B9E-F1E67535B730}")

            'add the buttons to the toolbar
            CommandBar.Controls.AddButton(m_TestButtonDef)



            'add the toolbar to the panel bar for the assembly environment
            AssemEnv = m_InventorApp.UserInterfaceManager.Environments.Item("AMxAssemblyEnvironment")
            Call AssemEnv.PanelBar.CommandBarList.Add(CommandBar)

            'add the toolbar to the panel bar for the part enviritment
            PartEnv = m_InventorApp.UserInterfaceManager.Environments.Item("PMxPartEnvironment")
            Call PartEnv.PanelBar.CommandBarList.Add(CommandBar)

            'add the toolbar to the panel bar for the part enviritment
            DrawEnv = m_InventorApp.UserInterfaceManager.Environments.Item("DLxDrawingEnvironment")
            Call DrawEnv.PanelBar.CommandBarList.Add(CommandBar)

            '1- Inventor - FWxMainFrameEnvironment
            '2- Assembly - AMxAssemblyEnvironment
            '3- Assembly Sketch - AMxAssemblySketchEnvironment
            '4- Weldment - AMxWeldmentEnvironment
            '5- Weldment Feature - AMxWeldmentFeatureEnvironment
            '6- Presentation - DXxPresentationEnvironment
            '7- Drawing - DLxDrawingEnvironment
            '8- Drawing Sketch - DLxDrawingSketchEnvironment
            '9- Drawing Custom View - DLxDrawingCustomViewEnvironment
            '10- Notebook - NBxNotebookEnvironment
            '11- Part - PMxPartEnvironment
            '12- 2D Sketch - PMxPartSketchEnvironment
            '13- 3D Sketch - PMxPartSketch3dEnvironment
            '14- Explicit - PMxPartSolidEditEnvironment
            '15- Construction - PMxPartConstructionEnvironment
            '16- iFeature - PMxiFeatureEnvironment
            '17- Sheetmetal - MBxSheetMetalEnvironment

        End If

    End Sub

    Private ReadOnly Property Automation() As Object Implements Inventor.ApplicationAddInServer.Automation
        Get
            Return Nothing
        End Get
    End Property

    Private Sub Deactivate() Implements Inventor.ApplicationAddInServer.Deactivate

        'delete the button definitions
 
        m_TestButtonDef.Delete()

        'm_ParamsButtonDef = Nothing

        m_TestButtonDef = Nothing

        Marshal.ReleaseComObject(m_InventorApp)
        m_InventorApp = Nothing

        GC.WaitForPendingFinalizers()
        GC.Collect()

    End Sub

    Private Sub ExecuteCommand(ByVal CommandID As Integer) Implements Inventor.ApplicationAddInServer.ExecuteCommand
        ' not used
    End Sub
#End Region


    Private Sub RunTestButtonDef_OnExecute(ByVal Context As Inventor.NameValueMap) Handles m_TestButtonDef.OnExecute


        'display the parameters dialog
        Dim m_Bohrungen_umfaerben As Bohrungen_umfaerben
        m_Bohrungen_umfaerben = New Bohrungen_umfaerben
        m_Bohrungen_umfaerben.ShowDialog()



    End Sub

    Private Sub UserInterfaceEvents_OnResetCommandBars(ByVal CommandBars As Inventor.ObjectsEnumerator, ByVal Context As Inventor.NameValueMap) Handles m_UserInterfaceEvents.OnResetCommandBars

        Dim CommandBar As Inventor.CommandBar
        For Each CommandBar In CommandBars
            If CommandBar.InternalName = "AnalyzeMechanismToolbarIntName" Then

                CommandBar.Controls.AddButton(m_TestButtonDef)

                Exit Sub
            End If
        Next CommandBar

    End Sub

    Private Sub UserInterfaceEvents_OnResetEnvironments(ByVal Environments As Inventor.ObjectsEnumerator, ByVal Context As Inventor.NameValueMap) Handles m_UserInterfaceEvents.OnResetEnvironments

        'make the analyze mechanism command bar accessible in the panel menu for the assembly
        Dim CommandBar As Inventor.CommandBar
        Dim Environment As Inventor.Environment
        For Each CommandBar In m_InventorApp.UserInterfaceManager.CommandBars

            'get the analyze mechanism command bar
            If CommandBar.InternalName = "AnalyzeMechanismToolbarIntName" Then

                For Each Environment In Environments
                    'get the assembly environment

                    If Environment.InternalName = "AMxAssemblyEnvironment" Then

                        'make the command bar accessible in the panel menu for the assembly environment
                        Environment.PanelBar.CommandBarList.Add(CommandBar)

                        Exit Sub
                    End If
                Next Environment
            End If
        Next CommandBar



    End Sub

#Region "COM Registration"

    ' Registers this class as an Add-In for Autodesk Inventor.
    ' This function is called when the assembly is registered for COM.
    <System.Runtime.InteropServices.ComRegisterFunction()> _
    Public Shared Sub RegisterFunction(ByVal t As Type)

        'call the method in the AddInRegistration class to register the AddIn
        AddInRegistration.RegisterInventorAddIn(t)

    End Sub

    ' Unregisters this class as an Add-In for Autodesk Inventor.
    ' This function is called when the assembly is unregistered.
    <System.Runtime.InteropServices.ComUnregisterFunction()> _
    Public Shared Sub UnregisterFunction(ByVal t As Type)

        'call the method in the AddInRegistration class to unregister the AddIn
        AddInRegistration.UnregisterInventorAddIn(t)

    End Sub

#End Region

End Class

#Region "ImageToPictureConverter"
Public NotInheritable Class ImageToPictureConverter
    Inherits System.Windows.Forms.AxHost

    Private Sub New()
        MyBase.New(Nothing)
    End Sub

    Public Shared Function Convert(ByVal image As System.Drawing.Image) As stdole.IPictureDisp
        Return CType(System.Windows.Forms.AxHost.GetIPictureDispFromPicture(image), stdole.IPictureDisp)
    End Function

End Class
#End Region