﻿Option Strict Off
Option Explicit On

Imports System.Drawing
Imports System.Windows.Forms
Imports Inventor




Public Class frm_Daten
    Inherits System.Windows.Forms.Form

    Dim oInventorApp As Inventor.Application
    Dim oBaugruppe As Inventor.AssemblyDocument
    Dim oDoc As Inventor.Document 'Inventor.PartDocument
    Dim oProp As Inventor.Property
    Dim oPropSets As Inventor.PropertySets
    Dim oMaterials As Inventor.Materials
    Dim ini As New Org.Mentalis.Files.IniReader("c:\Daten.ini")

    Public m_Projekt_Daten As New Projekt_Daten

    Public Shared m_frmdaten As New frm_Daten
    Public Shared m_projektdaten As New Projekt_Daten

    Public Shared Sub main()
        System.Windows.Forms.Application.Run(m_frmdaten)
        m_frmdaten.Show()
        'System.Windows.Forms.Application.Exit(m_frmdaten)
        ' Application.Exit()
    End Sub

    Private Sub frm_Daten_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        ini.Write("Position", "x", Me.Location.X)
        ini.Write("Position", "y", Me.Location.Y)
        ini.Write("Position", "Breite", Me.Width)
        ini.Write("Position", "Hoehe", Me.Height)
    End Sub



    Private Sub frm_Daten_ImeModeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ImeModeChanged

    End Sub

    Public Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim m_frm_Daten As New frm_Daten





        'Daten aus iProps auslesen und eintragen
        Daten_Eintragen()

        'Materialliste Füllen nur bei einem Bauteil
        If (oDoc.SubType <> "{4D29B490-49B2-11D0-93C3-7E0706000000}") And (oDoc.SubType <> "{9C464203-9BAE-11D3-8BAD-0060B0CE6BB4}") Then
            'MsgBox "material nicht auslesen"
        Else
            Materiallistefuellen()
        End If

        'Fenster immer im Vordergrund
        Me.TopMost = False

        'Projekte Auslesen

        Projekte_in_Cmbox_einlesen(cmbox_projekte)

        txt_Position.Visible = False

        'Position auslesen

        Dim Position_y, Breite As Integer
        Dim Position_x, Hoehe As Integer

        'MsgBox(auswahl_String)
        ini.Section = "Position" ' cmbox_projekte.Text
        Position_x = ini.ReadInteger("x")
        Position_y = ini.ReadInteger("y")
        Breite = ini.ReadInteger("Breite")
        Hoehe = ini.ReadInteger("Hoehe")
        'MsgBox("x: " & Position_x & " y: " & Position_y)
        Me.Location = New System.Drawing.Point(Position_x, Position_y)

        Me.Width = Breite
        Me.Height = Hoehe




    End Sub

    Public Sub Daten_Eintragen()
        oInventorApp = System.Runtime.InteropServices.Marshal.GetActiveObject("Inventor.Application")
        oDoc = oInventorApp.ActiveDocument '.ActiveDocument

        'oDoc.FullFileName
        tb_Datei_Name.Text = oDoc.DisplayName
        tb_Speicherort.Text = oDoc.FullFileName
        tb_Benennung.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Part Number").Value
        tb_Zeichnungsnummer.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Stock Number").Value
        tb_Rohrmass.Text = oDoc.PropertySets("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}").Item("Revision Number").Value
        tb_Zuliferer.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Vendor").Value
        tb_Projektnummer.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Project").Value
        tb_Kunde.Text = oDoc.PropertySets("{D5CDD502-2E9C-101B-9397-08002B2CF9AE}").Item("Company").Value
        tb_Titel.Text = oDoc.PropertySets("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}").Item("Title").Value
        tb_Thema.Text = oDoc.PropertySets("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}").Item("Subject").Value
        cmb_Materialliste.Text = oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Material").Value

        'Einzellteil oder Kaufteil
        If oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Catalog Web Link").Value = "5" Then
            rb_Einzelteil.Checked = True
            tb_Zeichnungsnummer.Enabled = True
        ElseIf oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Catalog Web Link").Value = "3" Then
            rb_Kaufteil.Checked = True
            tb_Zeichnungsnummer.Enabled = False
        Else
            rb_Einzelteil.Checked = False
            rb_Kaufteil.Checked = False
        End If

    End Sub
    Public Sub Materiallistefuellen()

        oDoc = oInventorApp.ActiveDocument
        oPropSets = oDoc.PropertySets
        oMaterials = oDoc.Materials

        Dim i As Integer
        Dim iMat As Integer
        Dim Material As String

        'Anzahl der Materialien rausfinden

        iMat = oMaterials.Count

        For i = 1 To iMat 'Materialliste füllen

            Material = oMaterials.Item(i).Name
            cmb_Materialliste.Items.Add(Material)

        Next
    End Sub

    Private Sub rb_Einzelteil_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rb_Einzelteil.CheckedChanged
        '1.Zeichnungsnummer generieren

        tb_Zeichnungsnummer.Text = Zeichnungsnummer_generieren.zeichnungsnummer_generieren(tb_Datei_Name.Text, tb_Datei_Name.Text, "Zeichnungsnummer")

        '2.Bazeichnung generieren
        tb_Benennung.Text = Zeichnungsnummer_generieren.zeichnungsnummer_generieren(tb_Datei_Name.Text, tb_Datei_Name.Text, "")
        tb_Zeichnungsnummer.Enabled = True
    End Sub

    Private Sub tb_Speicherort_MouseDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tb_Speicherort.MouseDoubleClick

        Dim sPfad As String


        sPfad = oDoc.FullFileName


        Dim iStart As Integer
        Dim iEnde As Integer

        iStart = 0
        iEnde = 0

        iStart = InStrRev(sPfad, "\", -1, vbTextCompare)
        iEnde = InStrRev(sPfad, ".", -1, vbTextCompare)
        sPfad = Mid(sPfad, 1, iStart)

        Shell("explorer.exe /e," & Chr(34) & sPfad & Chr(34), vbMaximizedFocus)

    End Sub

    Private Sub tb_Speicherort_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles tb_Speicherort.MouseHover

    End Sub

    Private Sub tb_Speicherort_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_Speicherort.TextChanged

    End Sub

    Private Sub rb_Kaufteil_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rb_Kaufteil.CheckedChanged
        tb_Zeichnungsnummer.Enabled = False

    End Sub

    Private Sub tb_Zeichnungsnummer_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_Zeichnungsnummer.TextChanged

    End Sub

    Private Sub cb_Daten_uebernehmen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_Daten_uebernehmen.Click

        Dim oApplication As Inventor.Application
        oApplication = GetObject(, "Inventor.Application")

        oDoc = oApplication.ActiveDocument

        oPropSets = oDoc.PropertySets

        If (oDoc.SubType <> "{4D29B490-49B2-11D0-93C3-7E0706000000}") And (oDoc.SubType <> "{9C464203-9BAE-11D3-8BAD-0060B0CE6BB4}") Then
            'MsgBox "material nicht auslesen"
        Else
            Dim oMaterial As Inventor.Material
            Dim omTest As String

            On Error Resume Next
            oMaterial = oDoc.Materials.Item(cmb_Materialliste.Text)
            If Err.Number Then
                Err.Clear()
                MsgBox("Material bitte Auswählen")
                Exit Sub
            End If
            'End If

        End If
        Dim Text As String

        oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Description").Value = tb_Benennung.Text
        oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Vendor").Value = tb_Zuliferer.Text
        oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Project").Value = tb_Projektnummer.Text
        oDoc.PropertySets("{D5CDD502-2E9C-101B-9397-08002B2CF9AE}").Item("Company").Value = tb_Kunde.Text
        oDoc.PropertySets("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}").Item("Revision Number").Value = tb_Rohrmass.Text
        If rb_Einzelteil.Checked = True Then
            oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Catalog Web Link").Value = "5"
        ElseIf rb_Kaufteil.Checked = True Then
            oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Catalog Web Link").Value = "3"
        Else
            oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Catalog Web Link").Value = ""
        End If

        oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Stock Number").Value = tb_Zeichnungsnummer.Text 'txt_zeichnungsnummer.Text
        oDoc.PropertySets("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}").Item("Title").Value = tb_Titel.Text 'txt_Titel.Text
        oDoc.PropertySets("{F29F85E0-4FF9-1068-AB91-08002B27B3D9}").Item("Subject").Value = tb_Thema.Text 'txt_Thema.Text

        'oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Material").Value = cmb_Materialliste.Text
        'oPropSets.Item("{32853F0F-3444-11d1-9E93-0060B03C1CA6}").ItemByPropId(kMaterialDesignTrackingProperties).Value = cmb_Materialliste.Text
        '--------------------------------------------------------
        If (oDoc.SubType <> "{4D29B490-49B2-11D0-93C3-7E0706000000}") And (oDoc.SubType <> "{9C464203-9BAE-11D3-8BAD-0060B0CE6BB4}") Then
            'MsgBox "material nicht auslesen"
        Else
            oDoc.PropertySets("{32853F0F-3444-11D1-9E93-0060B03C1CA6}").Item("Material").Value = cmb_Materialliste.Text
            MsgBox(oDoc.PropertySets.Item(1).Item(1).Value)
        End If
        '--------------------------------------------------------
        Me.Close()

    End Sub

    Private Sub cb_Aktualisieren_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cb_Aktualisieren.Click
        Daten_Eintragen()
        Materiallistefuellen()

    End Sub

    Private Sub cmb_Projekt_Anlegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Projekt_Anlegen.Click
        'Projekt_Daten.Show()
        m_Projekt_Daten = New Projekt_Daten
        m_Projekt_Daten.ShowDialog()




    End Sub

    Private Sub cmbox_projekte_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbox_projekte.SelectedIndexChanged
        Dim auswahl_String As String

        auswahl_String = cmbox_projekte.Text.Substring(0, 11)
        'MsgBox(auswahl_String)
        ini.Section = auswahl_String ' cmbox_projekte.Text
        tb_Titel.Text = ini.ReadString("Projektbezeichnung")
        tb_Thema.Text = ini.ReadString("Projektbezeichnung_2")
        tb_Kunde.Text = ini.ReadString("Kunde")
        tb_Projektnummer.Text = auswahl_String.Substring(0, 3) & " " & auswahl_String.Substring(3, 4) & " " & auswahl_String.Substring(7, 4)
        'auswahl_String.Substring(0, 4) & " " & auswahl_String.Substring(5, 4) & " " & auswahl_String.Substring(9, 3)

    End Sub
    Private Sub Projekte_in_Cmbox_einlesen(ByVal liste As Object)

        Dim ini As New Org.Mentalis.Files.IniReader("c:\test.ini")
        Dim cmb_String As String

        Dim es As IEnumerator = ini.GetSectionNames().GetEnumerator()
        While es.MoveNext()
            ini.Section = es.Current
            cmb_String = es.Current & " / " & ini.ReadString("Projektbezeichnung") & " / " & ini.ReadString("Kunde")
            liste.Items.Add(cmb_String)
        End While
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        'Me.Location = New Point(Me.Location.X, Me.Location.Y + 10)
    End Sub

    Private Sub cmb_Materialliste_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Materialliste.SelectedIndexChanged

    End Sub

    Private Sub cmb_Materialliste_SelectedValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Materialliste.SelectedValueChanged

    End Sub

    Private Sub Daten_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        txt_Position.Text = "Position X:" & Me.Location.X & "   Position Y:" & Me.Location.Y & vbCrLf _
                                & "Unten X:" & Me.Location.X & " Unten Y:" & Me.Location.Y + Me.Height

    End Sub

    Private Sub cmb_rohmasse_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Rohmasse.Click
        Dim odoc As Inventor.Document 'partdocument
        odoc = oInventorApp.ActiveDocument

        Dim ouom As UnitsOfMeasure
        ouom = odoc.UnitsOfMeasure

        Dim obody As SurfaceBody
        obody = odoc.componentdefinition.surfacebodies(1)

        MsgBox("wwttwt")

        'if odoc.subtype = "{9c464203-9bae-11d3-8bad-0060b0ce6bb4}" then
        'zen_auslesen()
        'exit sub
        'end if

        Try

            Dim a1, a2, a3, b1, b2, b3, x, y, z As Double

            a1 = ouom.GetStringFromValue(obody.RangeBox.MinPoint.X, ouom.LengthUnits)
            a2 = ouom.GetStringFromValue(obody.RangeBox.MinPoint.Y, ouom.LengthUnits)
            a3 = ouom.GetStringFromValue(obody.RangeBox.MinPoint.Z, ouom.LengthUnits)

            b1 = ouom.GetStringFromValue(obody.RangeBox.MaxPoint.X, ouom.LengthUnits)
            b2 = ouom.GetStringFromValue(obody.RangeBox.MaxPoint.Y, ouom.LengthUnits)
            b3 = ouom.GetStringFromValue(obody.RangeBox.MaxPoint.Z, ouom.LengthUnits)

            x = Val(a1) - Val(b1)

            If x < 0 Then
                x = x * (-1)
            End If

            y = Val(a2) - Val(b2)

            If y < 0 Then
                y = y * (-1)
            End If

            z = Val(a3) - Val(b3)

            If z < 0 Then
                z = z * (-1)
            End If

            Dim ausgabe As Double

            'ausgabe = ltrim(str(x)) & "x" & ltrim(str(y)) & "x" & ltrim(str(z))
            ausgabe = LTrim(Str(y)) & "x" & LTrim(Str(z)) & "x" & LTrim(Str(x))
            'endausgebe = ltrim(rtrim(ausgabe))
            tb_Rohrmass.Text = ausgabe



        Catch

            Select Case Err.Number    ' fehlernummer auswerten.
                Case 13    ' fehler "datei bereits geöffnet".
                    MsgBox("baugruppenrohrmasse können vorerst nicht ausgelesen werden" & Err.Number)    ' geöffnete datei schließen.
                Case Else
                    Exit Sub
            End Select

        End Try

    End Sub

    Private Sub frm_Daten_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LostFocus
        ini.Write("Position", "x", Me.Location.X)
        ini.Write("Position", "y", Me.Location.Y)
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Dim m_frm_Form1 As New Form1
        'm_frm_Form1.Show()
        'Public Sub TestSelection()
        ' Create a new clsSelect object.
        Dim oSelect As New clsSelect

        ' Call the pick method of the clsSelect object and set
        ' the filter to pick any face.
        Dim oFace As Face
        oFace = oSelect.Pick(SelectionFilterEnum.kPartFaceFilter)        'oSelect.Pick(kPartFaceFilter)

        ' Check to make sure an object was selected.
        If Not oFace Is Nothing Then
            ' Display the area of the selected face.
            MsgBox("Face area: " & oFace.Evaluator.Area & " cm^2")
        End If
        'End Sub

    End Sub

    'Private Sub cmb_Rohmasse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_Rohmasse.Click
    '    'Dim oDoc As Inventor.PartDocument
    '    'oDoc = oInventorApp.ActiveDocument

    '    'Dim oUOM As UnitsOfMeasure
    '    'oUOM = oDoc.UnitsOfMeasure

    '    'Dim oBody As SurfaceBody
    '    'oBody = oDoc.ComponentDefinition.SurfaceBodies(1)

    '    Dim x_Mass As String
    '    'x_Mass = m_Rohmasse("x_x") ', oDoc, oUOM, oBody)
    '    x_Mass = Rohmasse_n.m_Rohmasse("X_X")

    '    MsgBox(x_Mass)

    '    Dim ub As Integer
    '    ub = 11
    '    MsgBox(Test_Funktion.Test_1(ub))


    'End Sub
End Class
